﻿using System;
using System.IO;
using System.Net.Sockets;

namespace IMAPClient
{
    class Client
    {
        static void Main(string[] args)
        {
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try
            {
                socket.Connect("localhost", 143);
            }
            catch (Exception ex)
            {
                Console.Write("Virhe: " + ex.Message);
                Console.ReadKey();
                return;
            }

            NetworkStream ns = new NetworkStream(socket);

            StreamReader sr = new StreamReader(ns);
            StreamWriter sw = new StreamWriter(ns);

            Boolean keskustelu = true;
            String viesti = "";
            ImapState tila = ImapState.Unaunthenticated;
            int counter = 1;
            string user = "mrc";
            string pass = "secret";

            while (keskustelu)
            {
                viesti = sr.ReadLine();
                Console.WriteLine(viesti);
                String[] status = viesti.Split(' ');
                string vastaus = "";

                switch(tila)
                {
                    case ImapState.Unaunthenticated:
                        if(status[0] == "OK")
                        {
                            vastaus = "a" + counter.ToString("000") + " ";
                            vastaus += "login ";
                            vastaus += user + " " + pass;
                            sw.WriteLine(vastaus);
                            counter++;
                            tila = ImapState.Authenticated;
                        }
                        break;
                    case ImapState.Authenticated:
                        if(status[1] == "OK")
                        {
                            vastaus = "a" + counter.ToString("000") + " ";
                            vastaus += "list INBOX/\\ \"\"";
                            sw.WriteLine(vastaus);
                            counter++;
                            tila = ImapState.Logout;
                        }
                        break;
                    case ImapState.Logout:
                        vastaus = "a" + counter.ToString("000") + " ";
                        vastaus += "logout";
                        sw.WriteLine(vastaus);
                        break;
                    default:
                        break;
                }

                sw.Flush();
            }
            Console.ReadKey();

            sw.Close();
            sr.Close();
            ns.Close();
            socket.Close();
        }
    }

    enum ImapState : UInt16
    {
        Unaunthenticated,
        Authenticated,
        Selected,
        Logout
    }
}
