﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.IO;


namespace POP3Client
{
    class Client
    {
        static void Main(string[] args)
        {
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try
            {
                socket.Connect("localhost", 110);
            }
            catch (Exception ex)
            {
                Console.Write("Virhe: " + ex.Message);
                Console.ReadKey();
                return;
            }

            NetworkStream ns = new NetworkStream(socket);

            StreamReader sr = new StreamReader(ns);
            StreamWriter sw = new StreamWriter(ns);

            Boolean on = true;
            String viesti = "";
            POPTila tila = POPTila.Aloitus;
            AuthState authState = AuthState.UserState;

            while (on)
            {
                // Luetaan 
                viesti = sr.ReadLine();
                Console.WriteLine(viesti);
                String[] status = viesti.Split(' ');

                switch(tila)
                {
                    case POPTila.Aloitus:
                        if(status[0] == "+OK") 
                        {
                            sw.WriteLine("USER joalhelk");
                            tila = POPTila.Authorization;
                        }
                        break;
                    case POPTila.Authorization:
                        if(authState == AuthState.UserState && status[0] == "+OK")
                        {
                            authState = AuthState.PassState;
                            sw.WriteLine("PASS secretpass");

                        } else if (authState == AuthState.UserState && status[0] == "-ERR")
                        {
                            sw.WriteLine("USER joalhelk");
                        } else if (authState == AuthState.PassState && status[0] == "+OK")
                        {
                            authState = AuthState.UserState;
                            tila = POPTila.Transaction;
                            sw.WriteLine("LIST");
                        }
                        break;
                    case POPTila.Transaction:
                        if(status[0] == ".") { sw.WriteLine("QUIT"); tila = POPTila.Quit;  }
                        break;
                    case POPTila.Quit:
                        if(status[0] == "+OK") { on = false; }
                        break;
                    default:
                        Console.WriteLine("Error happened...");
                        sw.WriteLine("QUIT"); tila = POPTila.Quit;
                        break;
                }
                sw.Flush();
            }


            Console.ReadKey();

            sw.Close();
            sr.Close();
            ns.Close();
            socket.Close();
        }
    }

    enum POPTila : UInt16
    {
        Aloitus,
        Authorization,
        Transaction,
        Quit
    }

    enum AuthState : UInt16
    {
        UserState,
        PassState
    }
}
