﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace POP3GUI
{
    public partial class Form1 : Form
    {
        private POP3Client client;
        private bool connected  = false;
        private int port        = 110;

        public Form1()
        {
            InitializeComponent();
            client = new POP3Client();
            textBox2.Text = port.ToString();
            button2.Enabled = false;
        }

        private void label1_Click(object sender, EventArgs e)
        {}

        /// <summary>
        /// Handles the connect button click
        /// </summary>
        private void button1_Click(object sender, EventArgs e)
        {
            if(!connected)
            {
                DisplayMessage("Connecting to server...");
                Tuple<int, string> msg = client.Connect();
                if(msg.Item1 == 0)
                {
                    DisplayMessage(msg.Item2);
                    return;
                }

                DisplayMessage(msg.Item2);
                connect.Text = "Disconnect";
                connected = true;
                button2.Enabled = true;
            } else
            {
                client.Disconnect();
                DisplayMessage("Disconnected from the server");
                connect.Text = "Connect";
                connected = false;
                button2.Enabled = false;
            }
        }

        /// <summary>
        /// Function to send messages to server
        /// </summary>
        private void button2_Click(object sender, EventArgs e)
        {
            string payload = textBox1.Text;
            if (String.IsNullOrEmpty(payload) || String.IsNullOrWhiteSpace(payload)) return;

            string response = String.Empty;
            bool isList = payload.Split(' ')[0] == "LIST";
            response = isList ? SendListRequest(payload) : client.SendMessage(payload);

            DisplayMessage(response);
            textBox1.Text = "";
        }

        private string SendListRequest(string payload)
        {
            string status;
            string response = String.Empty;

            while(true)
            {
                response = client.SendMessage(payload);
                if (response.Split(' ')[0] == ".") return response;

                DisplayMessage(response);
                payload = null;
            }
        }

        private void DisplayMessage(string message)
        {
            messageTable.Text += message + "\r\n";
        }
    }
}
