﻿using System;
using System.IO;
using System.Net.Sockets;

namespace POP3GUI
{
    public class POP3Client
    {
        private Socket socket;
        private NetworkStream ns;
        private StreamReader sr;
        private StreamWriter sw;

        public POP3Client()
        {
            socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        }


        public Tuple<int, string> Connect()
        {
            try
            {
                socket.Connect("localhost", 110);
            }
            catch (Exception e)
            {
                string message = e.Message;
                return Tuple.Create(0, message);
            }

            ns = new NetworkStream(socket);
            sr = new StreamReader(ns);
            sw = new StreamWriter(ns);

            string msg = sr.ReadLine();

            return Tuple.Create(1, msg);
        }

        public string SendMessage(string message)
        {
            if(!String.IsNullOrEmpty(message))
            {
                sw.WriteLine(message);
                sw.Flush();
            }
            string response = sr.ReadLine();

            return response;
        }

        public void Disconnect()
        {
            sw.Close();
            sr.Close();
            ns.Close();
            socket.Close();
        }
    }
}
